'*******************************************************************************
'	Filename   : CodeV_bookmarks.vbs
'	Created    : 2013
'	Created by : Franois RIGUET
'	Comments   : dtecte les mot-cls des options et les mot-cls de contrle  
'               indente la macro
' Vous pouvez distribuer ce script librement, mais conservez cet en-tte svp
' You can freely distribute this script, but please keep this header intact
' Version 1.1 : added UCH option
'*******************************************************************************

Option Explicit

Const MODULE_NAME  = "CodeV_bookmarks"
Const MODULE_VER   = "1.1"
Const MODULE_TITLE = "Code V bookmarks" 

Sub Init
    addMenuItem "Code V bookmarks", "", "CodeV_bookmarks", "CTRL+ALT+B"
End Sub


Sub CodeV_bookmarks()
	Dim editor, line, str
	Dim regExBookmark_control, regExBookmark_endcontrol, regExBookmark_option, regEx_comment
	Dim found_bookmark_control, found_bookmark_endcontrol, found_bookmark_option, found_comment
	Set editor = newEditor()
	editor.assignActiveEditor
	
	runPSPadAction "aDelMarks"
	
	for line = 1 to editor.linesCount() 
		editor.caretx(1)
		editor.carety(line)
		str = editor.lineText()

		Set regExBookmark_endcontrol = New RegExp    
		regExBookmark_endcontrol.Pattern = "^\bEND\b"        
		regExBookmark_endcontrol.IgnoreCase = True    
		regExBookmark_endcontrol.Global = True      
		found_bookmark_endcontrol = regExBookmark_endcontrol.test(str)

		Set regExBookmark_control = New RegExp    
		regExBookmark_control.Pattern = "^\bFOR\b|^\bWHI\b|^\bUNT\b|^\bFCT\b"        
		regExBookmark_control.IgnoreCase = True    
		regExBookmark_control.Global = True      
		found_bookmark_control = regexBookmark_control.test(str)

		Set regExBookmark_option = New RegExp    
		regExBookmark_option.Pattern = "^\bALI\b|^\bANA\b|^\bAUT\b|^\bBEA\b|^\bBIO\b|^\bBPR\b|\bBSP\b|^\bCAM\b|^\bCAT\b|^\bCEF\b|^\bCOS\b|^\bCXP\b|^\bELE\b|^\bENV\b|^\bFAB\b|^\bFIE\b|^\bFMA\b|^\bFOO\b|^\bFOV\b|^\bGDE\b|^\bGHO\b|^\bGLD\b|^\bGLS\b|^\bIMS\b|^\bLIB\b|^\bLSF\b|^\bLTE\b|^\bLUM\b|^\bMTF\b|^\bMUL\b|^\bNAR\b|^\bPAR\b|^\bPMA\b|^\bPSF\b|^\bQUA\b|^\bRAD\b|^\bRIM\b|^\bSLD\b|^\bSPE\b|^\bSPO\b|^\bSSS\b|^\bTES\b|^\bTOD\b|^\bTOL\b|^\bTOR\b|^\bTRA\b|^\bUCH\b|^\bUGR\b|^\bV3D\b|^\bVIE\b|^\bWAV\b|^\bWEI\b|^\bPRV\b"        
		regExBookmark_option.IgnoreCase = True    
		regExBookmark_option.Global = True      
		found_bookmark_option = regexBookmark_option.test(str)

		Set regEx_comment = New RegExp    
		regEx_comment.Pattern = "^!"        
		regEx_comment.IgnoreCase = True    
		regEx_comment.Global = True      
		found_comment = regex_comment.test(str)

		if (found_comment or found_bookmark_endcontrol) then
		
		elseif (found_bookmark_control or found_bookmark_option) then
				runPSPadAction "aSetMark"
		end if
	next
	runPSPadAction "aMarkList"
End Sub
